# Method: projects.locations.namespaces.services.resolve

- [HTTP request](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.ResolveServiceResponse.SCHEMA_REPRESENTATION)
- [Authorization Scopes](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#body.aspect)
- [Try it!](https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#try-it)

Returns a `https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services#Service` and its associated endpoints. Resolving a service is not considered an active developer method.

### HTTP request

`POST https://servicedirectory.googleapis.com/v1beta1/{name=projects/*/locations/*/namespaces/*/services/*}:resolve`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The name of the service to resolve. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `servicedirectory.services.resolve` |

### Request body

The request body contains data with the following structure:

| JSON representation ||
|---|---|
| ``` { "maxEndpoints": integer, "endpointFilter": string } ``` |

| Fields ||
|---|---|
| `maxEndpoints` | `integer` Optional. The maximum number of endpoints to return. Defaults to 25. Maximum is 100. If a value less than one is specified, the Default is used. If a value greater than the Maximum is specified, the Maximum is used. |
| `endpointFilter` | `string` Optional. The filter applied to the endpoints of the resolved service. General `filter` string syntax: `<field> <operator> <value> (<logical connector>)` - `<field>` can be `name`, `address`, `port`, or `metadata.<key>` for map field - `<operator>` can be `<`, `>`, `<=`, `>=`, `!=`, `=`, `:`. Of which `:` means `HAS`, and is roughly the same as `=` - `<value>` must be the same data type as field - `<logical connector>` can be `AND`, `OR`, `NOT` Examples of valid filters: - `metadata.owner` returns endpoints that have a annotation with the key `owner`, this is the same as `metadata:owner` - `metadata.protocol=gRPC` returns endpoints that have key/value `protocol=gRPC` - `address=192.108.1.105` returns endpoints that have this address - `port>8080` returns endpoints that have port number larger than 8080 \* `name>projects/my-project/locations/us-east1/namespaces/my-namespace/services/my-service/endpoints/endpoint-c` returns endpoints that have name that is alphabetically later than the string, so "endpoint-e" is returned but "endpoint-a" is not - `metadata.owner!=sd AND metadata.foo=bar` returns endpoints that have `owner` in annotation key but value is not `sd` AND have key/value `foo=bar` - `doesnotexist.foo=bar` returns an empty list. Note that endpoint doesn't have a field called "doesnotexist". Since the filter does not match any endpoint, it returns no results For more information about filtering, see [API Filtering](https://aip.dev/160). |

### Response body

If successful, the response body contains data with the following structure:
The response message for `https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services/resolve#google.cloud.servicedirectory.v1beta1.LookupService.ResolveService`.

| JSON representation ||
|---|---|
| ``` { "service": { object (`https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services#Service`) } } ``` |

| Fields ||
|---|---|
| `service` | ``object (`https://docs.cloud.google.com/service-directory/docs/reference/rest/v1beta1/projects.locations.namespaces.services#Service`)`` |

### Authorization Scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).